(*
    LCS - A study for a simple differencing program
    Main window
    Copyright (c) 2002-2003 Alessandro Scotti
    http://www.ascotti.org/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*)
unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, ToolWin, ComCtrls,
  DiffLine, DiffFileEngine, DiffUndoBuffer, ImgList, ActnList,
  FormOptions;

type
  TMainForm = class(TForm)
    StatusBar: TStatusBar;
    ToolBar: TToolBar;
    PbxOverview: TPaintBox;
    MainMenu: TMainMenu;
    CmdFile: TMenuItem;
    CmdOpen: TMenuItem;
    N1: TMenuItem;
    CmdExit: TMenuItem;
    CmdSaveLeftFile: TMenuItem;
    CmdSaveLeftFileAs: TMenuItem;
    CmdSaveRightFile: TMenuItem;
    CmdSaveRightFileAs: TMenuItem;
    PopupLeft: TPopupMenu;
    PopCopyToRight: TMenuItem;
    PopDeleteBlockLeft: TMenuItem;
    N2: TMenuItem;
    PopSaveLeftFile: TMenuItem;
    PopSaveLeftFileAs: TMenuItem;
    PbxView1: TPaintBox;
    Splitter: TSplitter;
    PbxView2: TPaintBox;
    VertScrollBar: TScrollBar;
    PnlBottom: TPanel;
    HorzScrollBar: TScrollBar;
    N3: TMenuItem;
    CmdEdit: TMenuItem;
    ImageList: TImageList;
    BtnOpen: TToolButton;
    ToolButton2: TToolButton;
    BtnSaveAll: TToolButton;
    BtnSaveLeft: TToolButton;
    BtnSaveRight: TToolButton;
    PopupRight: TPopupMenu;
    PopCopyLinesToLeft: TMenuItem;
    PopDeleteBlockRight: TMenuItem;
    N4: TMenuItem;
    PopSaveRightFile: TMenuItem;
    PopSaveRightFileAs: TMenuItem;
    CmdHelp: TMenuItem;
    CmdAbout: TMenuItem;
    Bevel1: TBevel;
    ToolButton6: TToolButton;
    BtnUndo: TToolButton;
    BtnRedo: TToolButton;
    ToolButton9: TToolButton;
    BtnPrevDiff: TToolButton;
    BtnNextDiff: TToolButton;
    CmdSearch: TMenuItem;
    CmdFind: TMenuItem;
    CmdFindAgain: TMenuItem;
    N5: TMenuItem;
    CmdNextDifference: TMenuItem;
    CmdPreviousDifference: TMenuItem;
    ActionList: TActionList;
    ActionUndo: TAction;
    ActionRedo: TAction;
    CmdUndo: TMenuItem;
    CmdRedo: TMenuItem;
    FindDialog: TFindDialog;
    SaveDialogRight: TSaveDialog;
    SaveDialogLeft: TSaveDialog;
    PopCopySingleLineToRight: TMenuItem;
    PopCopySingleLineToLeft: TMenuItem;
    N6: TMenuItem;
    CmdPreferences: TMenuItem;
    N7: TMenuItem;
    CmdAutosynch: TMenuItem;
    N8: TMenuItem;
    CmdRefresh: TMenuItem;
    ToolButton1: TToolButton;
    BtnRefresh: TToolButton;
    N9: TMenuItem;
    PopPropertiesLeft: TMenuItem;
    N10: TMenuItem;
    PopPropertiesRight: TMenuItem;
    PopDeleteLineLeft: TMenuItem;
    PopDeleteLineRight: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure ScrollBarChange(Sender: TObject);
    procedure CmdOpenClick(Sender: TObject);
    procedure CmdExitClick(Sender: TObject);
    procedure PbxView1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PopCopyToRightClick(Sender: TObject);
    procedure PopDeleteBlockLeftClick(Sender: TObject);
    procedure PopDeleteBlockRightClick(Sender: TObject);
    procedure PopCopyLinesToLeftClick(Sender: TObject);
    procedure PbxView2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CmdAboutClick(Sender: TObject);
    procedure PbxOverviewMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure PbxOverviewMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PbxOverviewMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure SplitterMoved(Sender: TObject);
    procedure ActionUndoUpdate(Sender: TObject);
    procedure ActionRedoUpdate(Sender: TObject);
    procedure ActionUndoExecute(Sender: TObject);
    procedure ActionRedoExecute(Sender: TObject);
    procedure PbxView1StartDrag(Sender: TObject;
      var DragObject: TDragObject);
    procedure PbxView1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PbxView2DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure PbxView2DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure PbxView2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PbxView2StartDrag(Sender: TObject;
      var DragObject: TDragObject);
    procedure PbxView1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure PbxView1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure CmdSaveLeftFileClick(Sender: TObject);
    procedure CmdSaveRightFileClick(Sender: TObject);
    procedure BtnSaveAllClick(Sender: TObject);
    procedure CmdPreviousDifferenceClick(Sender: TObject);
    procedure CmdNextDifferenceClick(Sender: TObject);
    procedure CmdFindAgainClick(Sender: TObject);
    procedure FindDialogFind(Sender: TObject);
    procedure CmdFindClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure CmdSaveLeftFileAsClick(Sender: TObject);
    procedure CmdSaveRightFileAsClick(Sender: TObject);
    procedure PbxView1DblClick(Sender: TObject);
    procedure PbxView2DblClick(Sender: TObject);
    procedure PopCopySingleLineToRightClick(Sender: TObject);
    procedure PopCopySingleLineToLeftClick(Sender: TObject);
    procedure CmdPreferencesClick(Sender: TObject);
    procedure CmdRecentFilesClick(Sender: TObject);
    procedure CmdRefreshClick(Sender: TObject);
    procedure CmdAutosynchClick(Sender: TObject);
    procedure PopPropertiesLeftClick(Sender: TObject);
    procedure PopDeleteLineRightClick(Sender: TObject);
    procedure PopDeleteLineLeftClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    FDiffLineList: TDiffLineList; // The list of all difference lines
    FLines: TList; // The list of active difference lines (all lines except those deleted)
    FFileName1: string; // Name of first file
    FFileName2: string; // Name of second file
    FColorOneOnly: integer; // Color to display lines that belong to first file only
    FColorTwoOnly: integer; // Color to display lines that belong to second file only
    FColorDefault: integer; // Color to display lines that belong to both documents
    FColorMissingLine: integer; // Background color (if line index goes outside the valid range)
    FColorChangedLine: integer; // Color to display lines that were changed (e.g. by copying)
    FCurrentLine: integer; // Index of "current" line (for searches etc.)
    FOverviewBackground: TBitmap;
    FSizeView1: integer; // Size of left panel as percentage of client area
    FDefaultCaption: string; // Default form caption (grabbed at program startup)
    FUndoBuffer: TDiffUndoBuffer;
    FRedoBuffer: TDiffUndoBuffer;
    FFlags: integer; // Modification flags (if some doc has changed etc.)
    FSearchString: string; // Last search string
    FOptions: TAppOptions; // Application options (saved to settings file)
    FOptionsFileName: string; // Name of file where options are saved
    FCurrentUserName: string; // Username
    FHistoryLFile: TStringList; // History of loaded "left" files
    FHistoryRFile: TStringList; // History of loaded "right" files
    FHistoryRecent: TStringList; // History of recent comparisons

    function AllowCloseCurrentDocument: boolean;
    function GetDiffLine( I: integer ): TDiffLine;
    function GetLineFromOverview( Y: integer ): integer;
    function GetLineHeight: integer;
    function GetDefaultOverviewRect: TRect;
    function GetOverviewThumbRect: TRect;
    function GetVisibleLines: integer;
    function LoadFiles( F1, F2: string ): boolean;
    function SaveFile( Filename: string; Mode: TDiffLineMode ): boolean;
    function ValidateDragOver( Source: TObject; Y: integer ): boolean;
    procedure ChangeLineBlock( L: integer; ModeFrom, ModeTo: TDiffLineMode; Block: boolean );
    procedure DiffLineListChanged;
    procedure DisplayHint(Sender: TObject);
    procedure DoUndoOrRedo( PrimaryBuffer, BackupBuffer: TDiffUndoBuffer );
    procedure DrawOverviewBackground( C: TCanvas; var R: TRect );
    procedure ExecuteDragDrop( Source: TObject; SourceView: integer; ModeFrom, ModeTo: TDiffLineMode );
    procedure FindNext;
    procedure GotoNextDiff( Direction: integer );
    procedure HandleDoubleClick( Sender: TPaintBox; ModeFrom, ModeTo: TDiffLineMode );
    procedure LoadOptions;
    procedure ModificationFlagsChanged;
    procedure OnDropFiles( var M: TMessage ); message WM_DROPFILES;
    procedure SaveOptions;
    procedure SetViewPosition( L: integer );
    procedure UpdateFormCaption;
    procedure UpdateRecentFiles;
    procedure UpdateRecentFilesMenu;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses IniFiles, Math, ShellApi, FormOpenFiles, FormAbout, FormProperties,
  FormAutosynch;

{$R *.DFM}

function ExpandTabs( const L: string; TabSize: integer ): string;
var
  P: integer;
begin
  Result := L;
  P := Pos( #9, L );
  if( P > 0 ) then begin
    repeat
      Delete( Result, P, 1 );
      Insert( StringOfChar(' ',TabSize-((P-1) mod Tabsize)), Result, P );
      repeat
        Inc( P );
      until( Result[P] = #9 )or( Result[P] = #0 );
    until( Result[P] = #0 );
  end;
end;

const
  FLAG_FILE_ONE_MODIFIED = $01;
  FLAG_FILE_TWO_MODIFIED = $02;

  MAX_RECENT_FILES = 8;

  OPT_TABSIZE = 'TabSize';
  OPT_IGNOREBLANKS = 'IgnoreBlanks';
  OPT_BACKUPFILES = 'BackupSavedFiles';
  OPT_MAXIMIZEWINDOW = 'MaximizeMainWindow';
  OPT_RIGHTDBLCLICK_DELETES = 'DeleteOnRightDblClick';

  SECT_HISTORY_LFILE = '.LFile';
  SECT_HISTORY_RFILE = '.RFile';
  SECT_HISTORY_RECENT = '.Recent';

//Load options from the settings file
procedure TMainForm.LoadOptions;
var
  F: TMemIniFile;
procedure ReadHistory( const Sect: string; Hist: TStringList );
  var
    I: integer;
    P: integer;
    S: string;
  begin
    F.ReadSectionValues( FCurrentUserName+Sect, Hist );
    for I:=1 to Hist.Count do begin
      S := Hist[I-1];
      P := Pos( '=', S );
      if( P > 0 ) then begin
        Delete( S, 1, P );
        Hist[I-1] := S;
      end;
    end;
  end;
begin
  F := nil;
  try
    F := TMemIniFile.Create( FOptionsFileName );
    // Static options
    FOptions.DiffOptions.IgnoreBlanks := F.ReadInteger( FCurrentUserName, OPT_IGNOREBLANKS, 1 ) <> 0;
    FOptions.TabSize := F.ReadInteger( FCurrentUserName, OPT_TABSIZE, 4 );
    FOptions.BackupSavedFiles := F.ReadInteger( FCurrentUserName, OPT_BACKUPFILES, 1 ) <> 0;
    FOptions.MaximizeWindow := F.ReadInteger( FCurrentUserName, OPT_MAXIMIZEWINDOW, 0 ) <> 0;
    FOptions.DblClickOnRightFileDeletes := F.ReadInteger( FCurrentUserName, OPT_RIGHTDBLCLICK_DELETES, 0 ) <> 0;
    // Histories
    ReadHistory( SECT_HISTORY_LFILE, FHistoryLFile );
    ReadHistory( SECT_HISTORY_RFILE, FHistoryRFile );
    ReadHistory( SECT_HISTORY_RECENT, FHistoryRecent );
  except
  end;
  F.Free;
end;

function BoolToInt( B: boolean ): integer;
begin
  if( B ) then Result := 1 else Result := 0;
end;

// Save options to settings file
procedure TMainForm.SaveOptions;
var
  F: TMemIniFile;
procedure WriteHistory( const Sect: string; const Hist: TStringList );
  var
    I: integer;
  begin
    F.EraseSection( FCurrentUserName+Sect );
    for I:=0 to Hist.Count-1 do
      F.WriteString( FCurrentUserName+Sect, IntToStr(I), Hist[I] );
  end;
begin
  F := nil;
  try
    F := TMemIniFile.Create( FOptionsFileName );
    // Static options
    F.WriteInteger( FCurrentUserName, OPT_TABSIZE, FOptions.TabSize );
    F.WriteInteger( FCurrentUserName, OPT_BACKUPFILES, BoolToInt(FOptions.BackupSavedFiles) );
    F.WriteInteger( FCurrentUserName, OPT_IGNOREBLANKS, BoolToInt(FOptions.DiffOptions.IgnoreBlanks) );
    F.WriteInteger( FCurrentUserName, OPT_MAXIMIZEWINDOW, BoolToInt(FOptions.MaximizeWindow) );
    F.WriteInteger( FCurrentUserName, OPT_RIGHTDBLCLICK_DELETES, BoolToInt(FOptions.DblClickOnRightFileDeletes) );
    // Histories
    WriteHistory( SECT_HISTORY_LFILE, FHistoryLFile );
    WriteHistory( SECT_HISTORY_RFILE, FHistoryRFile );
    WriteHistory( SECT_HISTORY_RECENT, FHistoryRecent );
    // Update
    F.UpdateFile;
  except
  end;
  F.Free;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  I: integer;
  N: cardinal;
  B: array[1..256] of char;
  S, F1, F2: string;
begin
  FColorOneOnly := $00B0E0B0;
  FColorTwoOnly := $00B0B0FF;
  FColorDefault := clWindow;
  FColorMissingLine := clGray;
  FColorChangedLine := $00F0DCBE;

  FCurrentLine := -1;
  FDefaultCaption := Caption;
  FSizeView1 := 50;
  FOverviewBackground := TBitmap.Create;
  FRedoBuffer := TDiffUndoBuffer.Create;
  FUndoBuffer := TDiffUndoBuffer.Create;

  FOptions.DiffOptions.IgnoreBlanks := true;
  FOptions.TabSize := 4;
  FOptions.BackupSavedFiles := true;
  FSearchString := '';

  DragAcceptFiles( Handle, true );

  FFileName1 := '';
  FFileName2 := '';

  FLines := TList.Create;

  FHistoryLFile := TStringList.Create;
  FHistoryRFile := TStringList.Create;
  FHistoryRecent := TStringList.Create;

  FOptionsFileName := ChangeFileExt( Application.ExeName, '.settings' );

  FCurrentUserName := 'Default';
  N := Sizeof( B );
  if( GetUserName( @B, N ) ) then begin
    FCurrentUserName := StrPas(@B);
  end;

  LoadOptions;

  UpdateRecentFilesMenu;

  F1 := '';
  F2 := '';
  for I:=1 to ParamCount do begin
    S := Trim(ParamStr(I));
    if( S[1] <> '/' ) then begin
      if( F1 = '' ) then
        F1 := ExpandFileName(S)
      else if( F2 = '' ) then
        F2 := ExpandFileName(S);
    end;
  end;

  LoadFiles( F1, F2 );

  if( FOptions.MaximizeWindow ) then
    WindowState := wsMaximized;

  Application.OnHint := DisplayHint;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  UpdateRecentFiles;

  SaveOptions;

  FHistoryLFile.Free;
  FHistoryRFile.Free;
  FHistoryRecent.Free;

  FLines.Free;
  FDiffLineList.Free;
  FLines := nil;
  FDiffLineList := nil;

  FOverviewBackground.Free;
end;

// Returns the specified difference line from the list of active lines
function TMainForm.GetDiffLine( I: integer ): TDiffLine;
begin
  Result := nil;
  if( I >= 0 )and( I < FLines.Count ) then
    Result := FDiffLineList.Lines[ integer(FLines.Items[I]) ];
end;

// Called when the main document (a TDiffLineList) changes
procedure TMainForm.DiffLineListChanged;
var
  L: TDiffLine;
  I, M: integer;
  DiffCount1, DiffCount2: integer;
begin
  M := -1;
  FLines.Clear;
  DiffCount1 := 0;
  DiffCount2 := 0;
  if( FDiffLineList <> nil ) then begin
    // Build the actual list of lines (that have not been deleted)
    for I:=0 to FDiffLineList.Count-1 do begin
      L := FDiffLineList.Lines[I];
      if not (L.Mode in [dmDeletedFromFileOne,dmDeletedFromFileTwo]) then begin
        FLines.Add( pointer(I) );
      end;
      if( L.Mode in [dmFileOneOnly] ) then begin
        Inc( DiffCount1 );
      end
      else if( L.Mode in [dmFileTwoOnly] ) then begin
        Inc( DiffCount2 );
      end;
      if( Length(L.Line) > M ) then
        M := Length(L.Line);
    end;

    // Enable refresh button
    CmdRefresh.Enabled := true;
    BtnRefresh.Enabled := true;

    // Enable/disable find difference buttons
    BtnPrevDiff.Enabled := (DiffCount1 + DiffCount2) <> 0;
    BtnNextDiff.Enabled := (DiffCount1 + DiffCount2) <> 0;
    CmdPreviousDifference.Enabled := (DiffCount1 + DiffCount2) <> 0;
    CmdNextDifference.Enabled := (DiffCount1 + DiffCount2) <> 0;

    // Enable autosynch button
    CmdAutosynch.Enabled := (DiffCount1 + DiffCount2) <> 0;

    // Enable find buttons
    CmdFind.Enabled := true;
    CmdFindAgain.Enabled := true;

    // Resize controls
    I := HorzScrollBar.Position;
    if( I > M ) then
      I := M;
    HorzScrollBar.SetParams( I, 1, M );
    FormResize(Self);
    FormPaint(Self);

    if( (DiffCount1 + DiffCount2) = 0 ) then
      StatusBar.SimpleText := ' No differences found'
    else
      StatusBar.SimpleText := ' Files are different (L=+' + IntToStr(DiffCount1) + ', R=+' + IntToStr(DiffCount2) + ')';
    StatusBar.Hint := StatusBar.SimpleText;
  end;
end;

// Changes the status of a difference line or block, can be called with the index
// of any line inside the block
procedure TMainForm.ChangeLineBlock( L: integer; ModeFrom, ModeTo: TDiffLineMode; Block: boolean );
var
  I, J, N: integer;
  D: TDiffLine;
begin
  D := GetDiffLine( L );
  if( D <> nil ) then begin
    Assert( D.Mode = ModeFrom, 'Unexpected line mode for block operation' );
    I := L;
    J := L+1;
    if( Block ) then begin
      while( I > 0 )and( GetDiffLine(I-1).Mode = ModeFrom ) do
        Dec( I );
      while( J < FLines.Count )and( GetDiffLine(J).Mode = ModeFrom ) do
        Inc( J );
    end;
    // Now I is the first block line, J is one *past* the last block line...

    // ...create entry for undo
    N := integer(FLines.Items[I]);
    FUndoBuffer.Push( TDiffUndoItem.CreateFrom(ModeFrom,N,N-I+J,FFlags) );
    FRedoBuffer.Clear;
    ActionUndo.Enabled := true;
    ActionRedo.Enabled := false;

    // ...modify block
    while( I < J ) do begin
      GetDiffLine(I).Mode := ModeTo;
      Inc( I );
    end;

    // Update modification flags
    if( ModeTo in [dmDeletedFromFileOne,dmCopiedFromFileTwo] ) then
      FFlags := FFlags or FLAG_FILE_ONE_MODIFIED;
    if( ModeTo in [dmDeletedFromFileTwo,dmCopiedFromFileOne] ) then
      FFlags := FFlags or FLAG_FILE_TWO_MODIFIED;

    ModificationFlagsChanged;
    DiffLineListChanged;
  end;
end;

// Returns the height of one line in pixels
function TMainForm.GetLineHeight: integer;
begin
  Result := Abs( PbxView1.Font.Height ) + 4;
end;

// Returns the number of *fully* visible lines
function TMainForm.GetVisibleLines: integer;
begin
  // Note: take into account the size of the 3D border
  Result := (PbxView1.Height - 4) div GetLineHeight;
end;

function TMainForm.GetDefaultOverviewRect: TRect;
begin
  Result := Rect( 4, 2, PbxOverview.Width-6, PbxOverview.Height-2 );
end;

procedure TMainForm.SetViewPosition( L: integer );
begin
  if( L < 0 ) then
    L := 0;
  if( L > VertScrollBar.Max ) then
    L := VertScrollBar.Max;
  VertScrollBar.Position := L;
end;

procedure TMainForm.DrawOverviewBackground( C: TCanvas; var R: TRect );
var
  L1, L2: integer;
  M, M1, M2: TDiffLineMode;
  R1, R2: TRect;
  I: integer;
  W: integer;
begin
  if( FDiffLineList = nil ) then
    Exit;

  C.Pen.Color := clBlack;
  C.Brush.Color := clBtnFace;
  C.FillRect( R );
  W := ((R.Right - R.Left) - 2) div 2;
  R1 := Rect( R.Left, 0, R.Left + W, 0 );
  R2 := Rect( R.Right-W, 0, R.Right, 0 );

  L1 := 0;
  L2 := 0;

  M1 := dmNone;
  M2 := dmNone;
  for I:=0 to FLines.Count do begin
    if( I < FLines.Count ) then
      M := GetDiffLine( I ).Mode
    else
      M := dmNone;

    // Track lines that are only in file one
    if( M = dmFileOneOnly ) then begin
      if( M1 <> dmFileOneOnly ) then begin
        L1 := I;
        M1 := dmFileOneOnly;
      end
    end
    else if( M1 = dmFileOneOnly ) then begin
      // This is the end of a "file one only" block
      C.Brush.Color := FColorOneOnly;
      R1.Top := R.Top + L1 * (R.Bottom-R.Top) div FLines.Count;
      R1.Bottom := R.Top + I * (R.Bottom-R.Top) div FLines.Count;
      if( R1.Bottom < 3+R1.Top ) then
        R1.Bottom := R1.Top + 3;
      C.Rectangle( R1 );
      M1 := dmNone;
    end;

    // Track lines that are only in file two
    if( M = dmFileTwoOnly ) then begin
      if( M2 <> dmFileTwoOnly ) then begin
        L2 := I;
        M2 := dmFileTwoOnly;
      end
    end
    else if( M2 = dmFileTwoOnly ) then begin
      // This is the end of a "file two only" block
      C.Brush.Color := FColorTwoOnly;
      R2.Top := R.Top + L2 * (R.Bottom-R.Top) div FLines.Count;
      R2.Bottom := R.Top + I * (R.Bottom-R.Top) div FLines.Count;
      if( R2.Bottom < 3+R2.Top ) then
        R2.Bottom := R2.Top + 3;
      C.Rectangle( R2 );
      M2 := dmNone;
    end;
  end;
end;

function TMainForm.GetOverviewThumbRect: TRect;
var
  R1: TRect;
begin
  Assert( FLines.Count > 0 );
  R1 := GetDefaultOverviewRect;
  Result := Rect( R1.Left,
    R1.Top + VertScrollBar.Position * ((R1.Bottom-R1.Top)) div FLines.Count,
    R1.Right,
    0 );
  Result.Bottom := Min(R1.Bottom,2 + Result.Top + ((GetVisibleLines) * (R1.Bottom-R1.Top)) div FLines.Count);
end;

procedure TMainForm.FormPaint(Sender: TObject);
var
  I: integer;
  Y: integer;
  H: integer;
  N: integer;
  S: string;
  L: TDiffLine;
  C1, C2: TCanvas;
  R1, R2: TRect;
procedure DrawLine( B1, B2: integer );
  begin
    if( B1 <> 0 )or( B2 <> 0 ) then begin
      S := ExpandTabs( L.Line, FOptions.TabSize );
      if( HorzScrollBar.Position > 1 ) then
        S := Copy( S, HorzScrollBar.Position, Length(S) );
    end;
    if( B1 <> 0 ) then begin
      C1.Brush.Color := B1;
      C1.TextRect( R1, R1.Left, R1.Top, S );
    end
    else begin
      C1.Brush.Color := FColorMissingLine;
      C1.FillRect( R1 );
    end;
    if( B2 <> 0 ) then begin
      C2.Brush.Color := B2;
      C2.TextRect( R2, R2.Left, R2.Top, S );
    end
    else begin
      C2.Brush.Color := FColorMissingLine;
      C2.FillRect( R2 );
    end;
  end;
begin
  // Setup paint boxes
  C1 := PbxView1.Canvas;
  C1.Font.Assign( PbxView1.Font );
  C1.Font.Color := clBlack;
  C2 := PbxView2.Canvas;
  C2.Font.Assign( PbxView1.Font );
  C2.Font.Color := clBlack;

  // Initialize variables
  H := GetLineHeight;

  // Render left and right views
  for I:=0 to GetVisibleLines do begin // Note: there is one more line *intentionally*
    N := I + VertScrollBar.Position;
    L := GetDiffLine( N );
    Y := 2 + I*H;
    R1 := Rect( 2, Y, PbxView1.Width-2, Y+H );
    R2 := Rect( 2, Y, PbxView2.Width-2, Y+H );
    if( L <> nil ) then begin
      // Draw a separator line if needed
      if( I > 0 )and( GetDiffLine( N-1).Mode <> L.Mode ) then begin
        C1.Brush.Color := clBlack;
        C1.FillRect( Rect( 0, Y-1, PbxView1.Width, Y ) );
        C2.Brush.Color := clBlack;
        C2.FillRect( Rect( 0, Y-1, PbxView2.Width, Y ) );
      end;
      // Draw text with proper color and style
      if( N = FCurrentLine ) then begin
        C1.Font.Style := [fsBold];
        C2.Font.Style := [fsBold];
      end
      else begin
        C1.Font.Style := [];
        C2.Font.Style := [];
      end;
      case L.Mode of
        dmFileOneOnly:
          DrawLine( FColorOneOnly, 0 );
        dmFileTwoOnly:
          DrawLine( 0, FColorTwoOnly );
        dmBothFiles:
          DrawLine( FColorDefault, FColorDefault );
        dmCopiedFromFileOne,dmCopiedFromFileTwo:
          DrawLine( FColorChangedLine, FColorChangedLine );
      end;
    end
    else begin
      DrawLine( 0, 0 );
    end;
  end;

  // Draw the 3D border around left and right views
  R1 := Rect( 0, 0, PbxView1.Width, PbxView1.Height );
  DrawEdge( C1.Handle, R1, EDGE_SUNKEN, BF_RECT );
  R2 := Rect( 0, 0, PbxView2.Width, PbxView2.Height );
  DrawEdge( C2.Handle, R2, EDGE_SUNKEN, BF_RECT );

  // Render overview
  if( FDiffLineList <> nil ) then begin
    R1 := GetDefaultOverviewRect;
    R2 := GetOverviewThumbRect;
    with PbxOverview.Canvas do begin
      Draw( R1.Left, R1.Top, FOverviewBackground );
      Brush.Color := clBlack;
      FrameRect( R2 );
      InflateRect( R2, -1, -1 );
      FrameRect( R2 );
    end;
  end;
end;

procedure TMainForm.FormResize(Sender: TObject);
const
  RatioView1 : integer = 0;
var
  M: integer;
  N: integer;
  R: TRect;
begin
  // Resize file panels
  N := ClientWidth - PbxOverview.Width - Splitter.Width - VertScrollBar.Width;
  N := N * FSizeView1 div 100;
  if( Abs(PbxView1.Width-N) > 10 ) then begin
    // Resize only if the change is noticeable, otherwise it gets
    // quite annoying
    PbxView1.Width := N;
  end;
  //
  HorzScrollBar.Left := PbxView1.Left + 1;
  HorzScrollBar.Width := PbxView1.Width + Splitter.Width + PbxView2.Width - 2;

  // Resize status bar panels
  StatusBar.Panels[0].Width := Width * 3 div 4;
  StatusBar.SimpleText := StatusBar.Hint;

  if( FDiffLineList <> nil ) then begin
    // Update the vertical scroll bar
    N := GetVisibleLines;
    M := 0;
    if( N < FLines.Count ) then
      M := FLines.Count - N;
    if( VertScrollBar.Position > M ) then
      VertScrollBar.Position := M;
    VertScrollBar.Max := M;
    VertScrollBar.LargeChange := N;

    // Draw the overview background (cached into a bitmap)
    R := GetDefaultOverviewRect;
    OffsetRect( R, -R.Left, -R.Top );
    with FOverviewBackground do begin
      Width := R.Right - R.Left;
      Height := R.Bottom - R.Top;
      DrawOverviewBackground( Canvas, R );
    end;
  end;
end;

procedure TMainForm.ScrollBarChange(Sender: TObject);
begin
  FormPaint(Self);
  StatusBar.SimpleText := StatusBar.Hint;
end;

// Updates the GUI when the modification flags have changed
procedure TMainForm.ModificationFlagsChanged;
var
  F: boolean;
begin
  F := FFlags and FLAG_FILE_ONE_MODIFIED <> 0;
  BtnSaveAll.Enabled := F;
  BtnSaveLeft.Enabled := F;
  CmdSaveLeftFile.Enabled := F;
  CmdSaveLeftFileAs.Enabled := F;
  PopSaveLeftFile.Enabled := F;
  PopSaveLeftFileAs.Enabled := F;

  F := FFlags and FLAG_FILE_TWO_MODIFIED <> 0;
  BtnSaveAll.Enabled := F;
  BtnSaveRight.Enabled := F;
  CmdSaveRightFile.Enabled := F;
  CmdSaveRightFileAs.Enabled := F;
  PopSaveRightFile.Enabled := F;
  PopSaveRightFileAs.Enabled := F;
end;

function TMainForm.AllowCloseCurrentDocument: boolean;
  function AskSaveFile( Filename: string; Mode: TDiffLineMode ): boolean;
  var
    R: integer;
  begin
    Result := true;
    R := MessageDlg( 'File "' + Filename + '" has been modified, do you want to save it?',
      mtWarning, [mbYes,mbNo,mbCancel], 0 );
    case R of
      mrYes: Result := SaveFile(Filename, Mode);
      mrNo: ; // Nothing to do then
      else begin // Cancel
        Result := false;
        Exit;
      end
    end;
  end;
begin
  Result := true;

  if( FFlags and FLAG_FILE_ONE_MODIFIED <> 0 ) then begin
    Result := AskSaveFile( FFilename1, dmFileOneOnly );
  end;

  if( Result )and( FFlags and FLAG_FILE_TWO_MODIFIED <> 0 ) then begin
    Result := AskSaveFile( FFilename2, dmFileTwoOnly );
  end;
end;

procedure TMainForm.UpdateRecentFilesMenu;
const
  MenuStartPos : integer = 6;
var
  I: integer;
  M: TMenuItem;
  P: integer;
  S: string;
  T: string;
begin
  // First, remove all "recent files" items from the menu
  // (they start from the 6th position and finish in the 3rd from
  // last position included)
  for I:=CmdFile.Count-3 downto MenuStartPos do begin
    M := CmdFile.Items[I];
    CmdFile.Delete( I );
    M.Free;
  end;

  // Exit if nothing to do
  if( FHistoryRecent.Count <= 0 ) then
    Exit;

  // Insert the updated item list
  for I:=FHistoryRecent.Count-1 downto 0 do begin
    M := TMenuItem.Create( Self );
    S := '&' + IntToStr(I+1) + ' ' + FHistoryRecent[I];
    P := Pos( '|', S );
    Assert( P > 0 );
    T := Copy( S, P+1, Length(S) );
    S := Copy( S, 1, P-1 );
    M.Caption := S;
    M.Tag := I;
    M.OnClick := CmdRecentFilesClick;
    P := Pos( '|', T );
    Assert( P > 0 );
    Delete( T, P, 1 );
    Insert( ' / ', T, P );
    M.Hint := T;
    CmdFile.Insert( MenuStartPos, M );
  end;

  // Insert separator
  M := TMenuItem.Create( Self );
  M.Caption := '-';
  CmdFile.Insert( MenuStartPos, M );
end;

procedure TMainForm.UpdateRecentFiles;
var
  N1, N2, S: string;
  I: integer;
begin
  N1 := ExtractFileName( FFileName1 );
  N2 := ExtractFileName( FFileName2 );
  if( N1 <> '' )and( N2 <> '' ) then begin
    S := N1 + '/' + N2 + '|' + FFileName1 + '|' + FFileName2;
    I := FHistoryRecent.IndexOf(S);
    if( I >= 0 ) then begin // Already in the list, move to first position
      FHistoryRecent.Move( I, 0 );
    end
    else begin // Add to list
      FHistoryRecent.Insert( 0, S );
      while( FHistoryRecent.Count > MAX_RECENT_FILES ) do begin
        FHistoryRecent.Delete( FHistoryRecent.Count-1 );
      end;
    end;
  end;
end;

function StrRChr( C: char; const S: string ): integer;
var
  I: integer;
begin
  Result := 0;
  for I:=Length(S) downto 0 do begin
    if( S[I] = C ) then begin
      Result := I;
      break;
    end;
  end;
end;

// Shortens a file path so that it takes less space on display
function ShortenFilePath( FullName: string; MaxLen: integer ): string;
var
  N, P, R: string;
  I: integer;
begin
  Result := FullName;
  if( Length(FullName) > MaxLen ) then begin
    N := ExtractFileName( FullName );
    P := ExtractFilePath( FullName );
    I := Pos( '\', P );
    if( I > 0 ) then begin
      R := Copy( P, 1, I );
      Delete( P, 1, I );
      while( true ) do begin
        I := Pos( '\', P );
        if( I = 0 ) then
          break;
        if( (Length(R) + Length(N) + I) > MaxLen ) then
          break;
        R := R + Copy( P, 1, I );
        Delete( P, 1, I );
      end;
      if( P <> '' ) then
        R := R + '...\';
      Result := R + N;
    end
  end;
end;

procedure TMainForm.UpdateFormCaption;
const
  MaxFileCaptionLen = 45;
var
  C: string;
  A1, A2: boolean;
begin
  C := FDefaultCaption;
  A1 := FFileName1 <> '';
  A2 := FFileName2 <> '';
  if( A1 )or( A2 ) then begin
    C := C + ' - ';
    if( A1 ) then  C := C + ShortenFilePath(FFileName1,MaxFileCaptionLen);
    if( A1 and A2 ) then C := C + ' / ';
    if( A2 ) then  C := C + ShortenFilePath(FFileName2,MaxFileCaptionLen);
  end;
  Caption := C;
end;

// Loads and differences two files
function TMainForm.LoadFiles( F1, F2: string ): boolean;
var
  D: TDiffLineList;
begin
  Result := false;

  // Set default values
  if( F1 = '' ) then
    F1 := FFileName1;
  if( F2 = '' ) then
    F2 := FFileName2;

  if( F1 = '' )and( F2 = '' ) then // Nothing to do!
    Exit;

  // Compute the differences between the two files
  D := diffTextFiles( F1, F2, FOptions.DiffOptions );
  if( D <> nil ) then begin
    if( not AllowCloseCurrentDocument ) then
      Exit;

    UpdateRecentFiles;
    UpdateRecentFilesMenu;

    FFileName1 := F1;
    FFileName2 := F2;
    UpdateFormCaption;
    FDiffLineList.Free;
    FDiffLineList := D;
    FFlags := 0; // No file modified yet

    VertScrollBar.Position := 0;
    DiffLineListChanged;
    FUndoBuffer.Clear;
    ModificationFlagsChanged;
    FormResize(Self);
    Paint;

    Result := true;
  end
  else begin
    MessageDlg( 'Cannot generate the file differences.', mtError, [mbOk], 0 );
  end;
end;

procedure TMainForm.CmdOpenClick(Sender: TObject);
const
  UpdateHistories : boolean = true;
begin
  if( UpdateHistories ) then begin
    UpdateHistories := false;
    OpenForm.CboLeft.Items.Assign( FHistoryLFile );
    OpenForm.CboRight.Items.Assign( FHistoryRFile );
  end;
  if( OpenForm.ShowModal = mrOk ) then begin
    if( OpenForm.LeftFile = '' )and( OpenForm.RightFile = '' ) then
      Exit;
    if( LoadFiles( OpenForm.LeftFile, OpenForm.RightFile ) ) then begin
      FHistoryLFile.Assign( OpenForm.CboLeft.Items );
      FHistoryRFile.Assign( OpenForm.CboRight.Items );
    end;
  end;
end;

procedure TMainForm.CmdExitClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.PbxView1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  L: integer;
  P: TPoint;
begin
  // Get the index of the line under the cursor
  L := (Y - 2) div GetLineHeight + VertScrollBar.Position;
  if( L >= 0 )and( L < FLines.Count ) then case Button of
    mbRight: begin
      PopCopySingleLineToRight.Enabled := GetDiffLine(L).Mode = dmFileOneOnly;
      PopCopyToRight.Enabled := GetDiffLine(L).Mode = dmFileOneOnly;
      PopDeleteLineLeft.Enabled := GetDiffLine(L).Mode = dmFileOneOnly;
      PopDeleteBlockLeft.Enabled := GetDiffLine(L).Mode = dmFileOneOnly;
      PopupLeft.Tag := L; // Save selected line into popup menu tag
      P := ClientToScreen( Point( PbxView1.Left+X, PbxView1.Top+Y ) );
      PopupLeft.Popup( P.X, P.Y );
    end;
    mbLeft: if( Shift = [] ) then begin
    end;
  end;
end;

procedure TMainForm.PbxView2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  L: integer;
  P: TPoint;
begin
  // Get the index of the line under the cursor
  L := (Y - 2) div GetLineHeight + VertScrollBar.Position;
  if( L >= 0 )and( L < FLines.Count ) then case Button of
    mbRight: begin
      PopCopySingleLineToLeft.Enabled := GetDiffLine(L).Mode = dmFileTwoOnly;
      PopCopyLinesToLeft.Enabled := GetDiffLine(L).Mode = dmFileTwoOnly;
      PopDeleteLineRight.Enabled := GetDiffLine(L).Mode = dmFileTwoOnly;
      PopDeleteBlockRight.Enabled := GetDiffLine(L).Mode = dmFileTwoOnly;
      PopupRight.Tag := L; // Save selected line into popup menu tag
      P := ClientToScreen( Point( PbxView2.Left+X, PbxView2.Top+Y ) );
      PopupRight.Popup( P.X, P.Y );
    end;
    mbLeft: if( Shift = [] ) then begin
    end;
  end;
end;

procedure TMainForm.PopCopyToRightClick(Sender: TObject);
begin
  ChangeLineBlock( PopupLeft.Tag, dmFileOneOnly, dmCopiedFromFileOne, true );
end;

procedure TMainForm.PopDeleteBlockLeftClick(Sender: TObject);
begin
  ChangeLineBlock( PopupLeft.Tag, dmFileOneOnly, dmDeletedFromFileOne, true );
end;

procedure TMainForm.PopDeleteLineLeftClick(Sender: TObject);
begin
  ChangeLineBlock( PopupLeft.Tag, dmFileOneOnly, dmDeletedFromFileOne, false );
end;

procedure TMainForm.PopCopyLinesToLeftClick(Sender: TObject);
begin
  ChangeLineBlock( PopupRight.Tag, dmFileTwoOnly, dmCopiedFromFileTwo, true );
end;

procedure TMainForm.PopDeleteBlockRightClick(Sender: TObject);
begin
  ChangeLineBlock( PopupRight.Tag, dmFileTwoOnly, dmDeletedFromFileTwo, true );
end;

procedure TMainForm.PopDeleteLineRightClick(Sender: TObject);
begin
  ChangeLineBlock( PopupRight.Tag, dmFileTwoOnly, dmDeletedFromFileTwo, false );
end;

procedure TMainForm.PopCopySingleLineToRightClick(Sender: TObject);
begin
  ChangeLineBlock( PopupLeft.Tag, dmFileOneOnly, dmCopiedFromFileOne, false );
end;

procedure TMainForm.PopCopySingleLineToLeftClick(Sender: TObject);
begin
  ChangeLineBlock( PopupRight.Tag, dmFileTwoOnly, dmCopiedFromFileTwo, false );
end;

procedure TMainForm.CmdAboutClick(Sender: TObject);
begin
  AboutForm := TAboutForm.Create(Self);
  AboutForm.ShowModal;
  AboutForm.Free;
end;

procedure TMainForm.FormMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
  SetViewPosition( VertScrollBar.Position + WheelDelta div WHEEL_DELTA );
  Handled := true;
end;

function TMainForm.GetLineFromOverview( Y: integer ): integer;
var
  R: TRect;
  L: integer;
begin
  Result := -1;
  if( FDiffLineList <> nil ) then begin
    R := GetDefaultOverviewRect;
    if( Y < R.Top ) then
      Y := R.Top;
    L := (Y - R.Top) * FLines.Count div (R.Bottom-R.Top);
    if( L >= 0 )and( L < FLines.Count ) then begin
      Result := L;
    end;
  end;
end;

const
  FOvMouseDown: boolean = false;
var
  FOvDragging: boolean;
  FOvMousePos: TPoint;
  FOvDragLine: integer;

procedure TMainForm.PbxOverviewMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  L: integer;
begin
  if( FDiffLineList <> nil )and( FOvMouseDown )and( not FOvDragging ) then begin
    L := GetLineFromOverview( Y );
    if( L >= 0 ) then begin
      Dec( L, GetVisibleLines div 2 );
      SetViewPosition( L );
    end;
  end;
  FOvMouseDown := false;
end;

procedure TMainForm.PbxOverviewMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  R: TRect;
begin
  FOvMouseDown := true;
  FOvMousePos := Point( X, Y );
  R := GetOverviewThumbRect;
  FOvDragging := PtInRect( R, FOvMousePos );
  FOvDragLine := VertScrollBar.Position;
end;

procedure TMainForm.PbxOverviewMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  L: integer;
begin
  if( not FOvMouseDown ) then
    Exit;
  if( FOvDragging ) then begin
    if( Y > FOvMousePos.Y ) then
      L := FOvDragLine + GetLineFromOverview( Y-FOvMousePos.Y )
    else
      L := FOvDragLine - GetLineFromOverview( FOvMousePos.Y-Y );
    SetViewPosition( L );
  end;
end;

procedure TMainForm.SplitterMoved(Sender: TObject);
var
  N: integer;
begin
  N := ClientWidth - PbxOverview.Width - Splitter.Width - VertScrollBar.Width;
  FSizeView1 := PbxView1.Width * 100 div N;
end;

procedure TMainForm.ActionUndoUpdate(Sender: TObject);
begin
  BtnUndo.Enabled := ActionUndo.Enabled;
  CmdUndo.Enabled := ActionUndo.Enabled;
end;

procedure TMainForm.ActionRedoUpdate(Sender: TObject);
begin
  BtnRedo.Enabled := ActionRedo.Enabled;
  CmdRedo.Enabled := ActionRedo.Enabled;
end;

procedure TMainForm.DoUndoOrRedo( PrimaryBuffer, BackupBuffer: TDiffUndoBuffer );
var
  I, J: integer;
  U: TDiffUndoItem;
  M: TDiffLineMode;
  F: integer;
  UB: TDiffUndoBuffer;
begin
  U := PrimaryBuffer.Pop;
  if( U <> nil ) then begin
    M := U.Mode; // Mode to set
    F := U.Flags; // Flags to set

    if( M = dmNone ) then begin
      // The undo operation uses a secondary buffer (note: no redo for this)
      UB := TDiffUndoBuffer( U.Data );
      Assert( UB <> nil );

      for I:=1 to UB.Count do begin
        U := UB.Items[I-1];
        for J:=U.LineFrom to U.LineTo-1 do begin
          FDiffLineList.Lines[J].Mode := U.Mode;
        end;
      end;

      UB.Free; // Free secondary buffer
      FRedoBuffer.Clear; // No redo for this operation
    end
    else begin
      // The undo operation only uses the current undo item
      U.Mode := FDiffLineList.Lines[ U.LineFrom ].Mode; // Old mode to backup
      U.Flags := FFlags;
      // Change mode of block
      for I:=U.LineFrom to U.LineTo-1 do begin
        FDiffLineList.Lines[ I ].Mode := M;
      end;
      // Save action in the backup buffer
      BackupBuffer.Push( U );
    end;

    // Update
    FFlags := F;
    ModificationFlagsChanged;
    DiffLineListChanged;
    ActionUndo.Enabled := FUndoBuffer.Count > 0;
    ActionRedo.Enabled := FRedoBuffer.Count > 0;
  end;
end;

procedure TMainForm.ActionUndoExecute(Sender: TObject);
begin
  DoUndoOrRedo( FUndoBuffer, FRedoBuffer );
end;

procedure TMainForm.ActionRedoExecute(Sender: TObject);
begin
  DoUndoOrRedo( FRedoBuffer, FUndoBuffer );
end;

// Handles file dragged from another application
procedure TMainForm.OnDropFiles( var M: TMessage );
var
  Drop: THandle;
  Name: array[ 1..MAX_PATH ] of char;
  N: integer;
  F1, F2: string;
  DW: DWORD;
  P: TPoint;
begin
  Drop := M.WParam;
  N := DragQueryFile( Drop, $FFFFFFFF, nil, 0 );
  if( N > 0 ) then begin
    F1 := '';
    F2 := '';
    // Get name of first file
    DragQueryFile( Drop, 0, @Name, sizeof(Name) );
    if( N = 1 ) then begin
      // Only one file was dropped, need to use mouse position to
      // select left or right window
      DW := GetMessagePos;
      P.X := LOWORD(DW);
      P.Y := HIWORD(DW);
      P := ScreenToClient( P );
      if( PtInRect( PbxView1.BoundsRect, P ) ) then
        F1 := StrPas(@Name)
      else
        F2 := StrPas(@Name);
    end
    else begin
      // Two or more files, use first two names
      F1 := StrPas(@Name);
      DragQueryFile( Drop, 1, @Name, sizeof(Name) );
      F2 := StrPas(@Name);
    end;
    LoadFiles( F1, F2 );
  end;
  DragFinish( Drop );
  M.Result := 0;
end;

type
  TBlockDragObject = class(TDragObject)
  public
    LoLine, HiLine, Source: integer;
    constructor Create( ALoLine, AHiLine, ASource: integer );
  end;

constructor TBlockDragObject.Create;
begin
  LoLine := ALoLine;
  HiLine := AHiLine;
  Source := ASource;
end;

const
  FDragLineView: integer = -1;

procedure TMainForm.PbxView1StartDrag(Sender: TObject;
  var DragObject: TDragObject);
var
  L, H: integer;
begin
  L := FDragLineView;
  if( L >= 0 ) then begin
    H := L;
    while( L > 0 )and( GetDiffLine(L-1).Mode = dmFileOneOnly ) do
      Dec( L );
    while( H < FLines.Count )and( GetDiffLine(H).Mode = dmFileOneOnly ) do
      Inc( H );
    DragObject := TBlockDragObject.Create( L, H, 1 );
  end;
end;

procedure TMainForm.PbxView2StartDrag(Sender: TObject;
  var DragObject: TDragObject);
var
  L, H: integer;
begin
  L := FDragLineView;
  if( L >= 0 ) then begin
    H := L;
    while( L > 0 )and( GetDiffLine(L-1).Mode = dmFileTwoOnly ) do
      Dec( L );
    while( H < FLines.Count )and( GetDiffLine(H).Mode = dmFileTwoOnly ) do
      Inc( H );
    DragObject := TBlockDragObject.Create( L, H, 2 );
  end;
end;

procedure TMainForm.PbxView1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  L: integer;
begin
  if( Button <> mbLeft )or( Shift <> [ssLeft] ) then
    Exit;
  L := (Y - 2) div GetLineHeight + VertScrollBar.Position;
  if( L < 0 )or( L >= FLines.Count ) then
    Exit;
  if( GetDiffLine(L).Mode = dmFileOneOnly ) then begin
    FDragLineView := L;
    PbxView1.BeginDrag( false );
  end;
end;

procedure TMainForm.PbxView2MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  L: integer;
begin
  if( Button <> mbLeft )or( Shift <> [ssLeft] ) then
    Exit;
  L := (Y - 2) div GetLineHeight + VertScrollBar.Position;
  if( L < 0 )or( L >= FLines.Count ) then
    Exit;
  if( GetDiffLine(L).Mode = dmFileTwoOnly ) then begin
    FDragLineView := L;
    PbxView2.BeginDrag( false );
  end;
end;

function TMainForm.ValidateDragOver( Source: TObject; Y: integer ): boolean;
var
  L: integer;
  O: TBlockDragObject;
begin
  Result := false;
  if( not IsDragObject(Source) ) then
    Exit;
  L := (Y - 2) div GetLineHeight + VertScrollBar.Position;
  if( L < 0 )or( L >= FLines.Count ) then
    Exit;
  O := Source as TBlockDragObject;
  if( L < O.LoLine )or( L >= O.HiLine ) then
    Exit;
  Result := true;
end;

procedure TMainForm.PbxView1DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept := ValidateDragOver( Source, Y );
end;

procedure TMainForm.PbxView2DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept := ValidateDragOver( Source, Y );
end;

procedure TMainForm.ExecuteDragDrop( Source: TObject; SourceView: integer; ModeFrom, ModeTo: TDiffLineMode );
var
  O: TBlockDragObject;
begin
  if( not IsDragObject(Source) ) then
    Exit;
  O := Source as TBlockDragObject;
  if( O.Source <> SourceView ) then
    Exit;
  ChangeLineBlock( O.LoLine, ModeFrom, ModeTo, true );
end;

procedure TMainForm.PbxView1DragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
  ExecuteDragDrop( Source, 2, dmFileTwoOnly, dmCopiedFromFileTwo );
end;

procedure TMainForm.PbxView2DragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
  ExecuteDragDrop( Source, 1, dmFileOneOnly, dmCopiedFromFileOne );
end;

// Saves either the "left" or "right" part of the document (according
// to the specified mode) to file
function TMainForm.SaveFile( Filename: string; Mode: TDiffLineMode ): boolean;
var
  B: string;
  F: TextFile;
  I: integer;
  L: TDiffLine;
  M: integer;
begin
  Result := false;

  // Backup file if needed
  if( FOptions.BackupSavedFiles )and( FileExists(Filename) ) then begin
    B := Filename + '.bak';
    if( not CopyFile( PChar(Filename), PChar(B), false ) ) then begin
      MessageDlg( 'Cannot create "' + B + '". Save operation aborted.',
        mtError, [mbOk], 0 );
      Exit;
    end;
    FileSetAttr( B, faArchive );
  end;

  // Create and write the output file
  AssignFile( F, Filename );

  try
    Rewrite( F );
  except
    on E: Exception do begin
        MessageDlg( 'Cannot write file. ' + E.Message + '.', mtError, [mbOk], 0 );
        Exit;
      end;
  else
    MessageDlg( 'Cannot write on output file (unspecified error).', mtError, [mbOk], 0 );
    Exit;
  end;

  for I:=0 to FDiffLineList.Count-1 do begin
    L := FDiffLineList.Lines[I];
    if( L.Mode in [dmBothFiles,dmCopiedFromFileOne,dmCopiedFromFileTwo] )or( L.Mode = Mode ) then begin
      // We output the lines that belong to both files, plus those
      // that belong only to the specified file (dmFileOneOnly or dmFileTwoOnly)
      WriteLn( F, L.Line );
    end;
  end;

  CloseFile( F );

  // If we managed to save the file without errors, we must now update
  // the undo/redo buffers.
  // The idea is this: when a document is saved, the modification flag
  // must be oviously reset. However, we have a history of past modifications
  // where the flag could have also been cleared at some time (this happens
  // when the *other* file is modified for example) and this is no longer
  // true because the modification status in the history refers to the original
  // file, which we have now changed because of the save operation.
  // So we have to scan the undo/redo buffer and make sure to set the
  // modification flags corresponding to the saved file.
  if( Mode = dmFileOneOnly ) then begin
    M := FLAG_FILE_ONE_MODIFIED;
  end
  else begin
    M := FLAG_FILE_TWO_MODIFIED;
  end;
  FFlags := FFlags and (not M);
  for I:=0 to FUndoBuffer.Count-1 do begin
    FUndoBuffer.Items[I].Flags := FUndoBuffer.Items[I].Flags or M;
  end;
  for I:=0 to FRedoBuffer.Count-1 do begin
    FRedoBuffer.Items[I].Flags := FRedoBuffer.Items[I].Flags or M;
  end;

  ModificationFlagsChanged;

  Result := true;
end;

procedure TMainForm.CmdSaveLeftFileClick(Sender: TObject);
begin
  SaveFile( FFileName1, dmFileOneOnly );
end;

procedure TMainForm.CmdSaveRightFileClick(Sender: TObject);
begin
  SaveFile( FFileName2, dmFileTwoOnly );
end;

procedure TMainForm.BtnSaveAllClick(Sender: TObject);
begin
  CmdSaveLeftFileClick(Sender);
  CmdSaveRightFileClick(Sender);
end;

procedure TMainForm.GotoNextDiff( Direction: integer );
var
  I: integer;
  D: TDiffLine;
  M: TDiffLineMode;
begin
  Assert( Direction <> 0 );

  I := VertScrollBar.Position;

  // If this is a "changed" block, get out of it
  D := GetDiffLine( I );
  if( D <> nil ) then begin
    M := D.Mode;
    if( M in [dmFileOneOnly,dmFileTwoOnly] ) then begin
      while( D <> nil )and( D.Mode = M ) do begin
        I := I + Direction;
        D := GetDiffLine( I );
      end
    end;
  end;

  // Now go to the next "changed" block
  while( D <> nil ) do begin
    if( D.Mode in [dmFileOneOnly,dmFileTwoOnly] ) then begin
      // If going backwards, set the position to the block start
      if( Direction < 0 ) then begin
        M := D.Mode;
        while( D <> nil )and( D.Mode = M ) do begin
          I := I + Direction;
          D := GetDiffLine(I);
        end;
        I := I - Direction;
      end;
      VertScrollBar.Position := I;
      Exit;
    end;
    I := I + Direction;
    D := GetDiffLine(I);
  end;
end;

procedure TMainForm.CmdPreviousDifferenceClick(Sender: TObject);
begin
  GotoNextDiff( -1 );
end;

procedure TMainForm.CmdNextDifferenceClick(Sender: TObject);
begin
  GotoNextDiff( +1 );
end;

procedure TMainForm.FindNext;
var
  MatchCase: boolean;
  SearchText, SearchLine: string;
  Line: TDiffLine;
  N, M: integer;
begin
  SearchText := FindDialog.FindText;
  if( SearchText = '' ) then
    Exit;
  MatchCase := frMatchCase in FindDialog.Options;
  if( not MatchCase ) then
    SearchText := UpperCase(SearchText);
  repeat
    if( frDown in FindDialog.Options ) then
      Inc( FCurrentLine )
    else
      Dec( FCurrentLine );
    Line := GetDiffLine( FCurrentLine );
    if( Line <> nil ) then begin
      if( MatchCase ) then
        SearchLine := Line.Line
      else
        SearchLine := Uppercase(Line.Line);
      if( Pos( SearchText, SearchLine ) > 0 ) then begin
        // Found
        N := FCurrentLine - GetVisibleLines div 2;
        M := VertScrollBar.Position;
        SetViewPosition( N );
        if( VertScrollBar.Position = M ) then begin
          FormPaint(Self);
        end;
        Exit;
      end;
    end;
  until( Line = nil );
  FCurrentLine := -1;
  StatusBar.SimpleText := ' Search text "' + FindDialog.FindText + '" not found';
  FormPaint(Self);
end;

procedure TMainForm.CmdFindAgainClick(Sender: TObject);
begin
  if( FCurrentLine >= 0 ) then
    FindNext;
end;

procedure TMainForm.FindDialogFind(Sender: TObject);
begin
  FindDialog.CloseDialog;
  FCurrentLine := VertScrollBar.Position;
  if( frDown in FindDialog.Options ) then
    Dec( FCurrentLine )
  else
    Inc( FCurrentLine );
  FindNext;
end;

procedure TMainForm.CmdFindClick(Sender: TObject);
begin
  FindDialog.Execute;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := AllowCloseCurrentDocument;
end;

procedure TMainForm.CmdSaveLeftFileAsClick(Sender: TObject);
begin
  if( SaveDialogLeft.InitialDir = '' ) then begin
    SaveDialogLeft.InitialDir := ExtractFilePath( FFilename1 );
  end;
  SaveDialogLeft.FileName := FFilename1;
  if( SaveDialogLeft.Execute ) then begin
    if SaveFile( SaveDialogLeft.FileName, dmFileOneOnly ) then begin
      FFilename1 := SaveDialogLeft.FileName;
    end;
  end;
end;

procedure TMainForm.CmdSaveRightFileAsClick(Sender: TObject);
begin
  if( SaveDialogRight.InitialDir = '' ) then begin
    SaveDialogRight.InitialDir := ExtractFilePath( FFilename2 );
  end;
  SaveDialogRight.FileName := FFilename2;
  if( SaveDialogRight.Execute ) then begin
    if SaveFile( SaveDialogRight.FileName, dmFileTwoOnly ) then begin
      FFilename2 := SaveDialogRight.FileName;
      UpdateFormCaption;
    end;
  end;
end;

procedure TMainForm.HandleDoubleClick( Sender: TPaintBox; ModeFrom, ModeTo: TDiffLineMode );
var
  P: TPoint;
  L: integer;
begin
  // Note: in theory we need the mouse position when it double clicked,
  // however this is enough for this program!
  GetCursorPos( P );
  P := Sender.ScreenToClient( P );

  // Get the index of the line under the cursor
  L := (P.Y - 2) div GetLineHeight + VertScrollBar.Position;
  if( L >= 0 )and( L < FLines.Count ) then begin
    if( GetDiffLine(L).Mode = ModeFrom ) then begin
      ChangeLineBlock( L, ModeFrom, ModeTo, true );
    end;
  end;
end;

procedure TMainForm.PbxView1DblClick(Sender: TObject);
begin
  HandleDoubleClick( PbxView1, dmFileOneOnly, dmCopiedFromFileOne );
end;

procedure TMainForm.PbxView2DblClick(Sender: TObject);
var
  ModeTo: TDiffLineMode;
begin
  if( FOptions.DblClickOnRightFileDeletes ) then
    ModeTo := dmDeletedFromFileTwo
  else
    ModeTo := dmCopiedFromFileTwo;
  HandleDoubleClick( PbxView2, dmFileTwoOnly, ModeTo );
end;

procedure TMainForm.CmdPreferencesClick(Sender: TObject);
begin
  OptionsForm := TOptionsForm.Create(Self);
  OptionsForm.SetOptions( FOptions );
  if( OptionsForm.ShowModal = mrOk ) then begin
    OptionsForm.GetOptions( FOptions );
    FormPaint( Self );
  end;
  OptionsForm.Free;
end;

// Reload a recent file difference operation
procedure TMainForm.CmdRecentFilesClick(Sender: TObject);
var
  M: TMenuItem;
  P: integer;
  S, N1, N2: string;
procedure RemoveBadItem;
  begin
    FHistoryRecent.Delete( M.Tag );
    UpdateRecentFilesMenu;
  end;
begin
  M := Sender as TMenuItem;
  S := FHistoryRecent[ M.Tag ];
  P := Pos( '|', S );
  if( P = 0 ) then begin
    RemoveBadItem;
    Exit;
  end;
  Delete( S, 1, P );
  P := Pos( '|', S );
  if( P = 0 ) then begin
    RemoveBadItem;
    Exit;
  end;
  N1 := Copy( S, 1, P-1 );
  N2 := Copy( S, P+1, Length(S) );
  if( N1 = '' )or( N2 = '' ) then begin
    RemoveBadItem;
    Exit;
  end;
  LoadFiles( N1, N2 );
end;

procedure TMainForm.CmdRefreshClick(Sender: TObject);
begin
  // Refresh
  LoadFiles( '', '' );
end;

procedure TMainForm.CmdAutosynchClick(Sender: TObject);
var
  UB: TDiffUndoBuffer;
  UI: TDiffUndoItem;
  I, N1, N2: integer;
  D: TDiffLine;
  M: TDiffLineMode;
  LinesToSynch: set of TDiffLineMode;
begin
  if( AutosynchForm.ShowModal <> mrOk ) then
    Exit;

  LinesToSynch := [];
  if( AutosynchForm.ChkCopy.Checked ) then
    LinesToSynch := LinesToSynch + [dmFileOneOnly];
  if( AutosynchForm.ChkDelete.Checked ) then
    LinesToSynch := LinesToSynch + [dmFileTwoOnly];

  // Since this operation can change a number of blocks,
  // we use a separate undo buffer to hold all the changes.
  // This buffer is then stored into the main undo buffer,
  // so that this operation can be stored and undone as
  // a single item.
  UB := TDiffUndoBuffer.Create;

  // Scan the active lines list to look for differences
  I := 0;
  while( I < FLines.Count ) do begin
    N1 := integer( FLines.Items[I] );
    D := FDiffLineList.Lines[ N1 ];
    M := dmNone;
    if( D <> nil ) then
      M := D.Mode; // Should never be nil!
    if( M in LinesToSynch ) then begin
      // We must change this block
      N2 := N1 + 1;
      while( N2 < FLines.Count )and( GetDiffLine(N2).Mode = M ) do
        Inc( N2 );
      // ...now N2 points one line *past* the end of the block

      // Save the operation for undo
      UB.Push( TDiffUndoItem.CreateFrom( M, N1, N2, 0 ) );

      // Change the block
      while( N1 < N2 ) do begin
        D := GetDiffLine( N1 );
        if( M = dmFileOneOnly ) then
          D.Mode := dmCopiedFromFileOne
        else if( M = dmFileTwoOnly ) then
          D.Mode := dmDeletedFromFileTwo
        else
          Assert( false );
        Inc( N1 );
      end;

      I := N2 - 1; // Subtract one to compensate for the increment below
    end;
    Inc( I );
  end;

  // Did we change the document?
  if( UB.Count > 0 ) then begin
    // Push the whole undo buffer we built as a single undo item
    UI := TDiffUndoItem.CreateFrom( dmNone, 0, 0, FFlags );
    UI.Data := UB;
    FUndoBuffer.Push( UI );
    FRedoBuffer.Clear;
    ActionUndo.Enabled := true;
    ActionRedo.Enabled := false;

    // This operation only changes the second file
    FFlags := FFlags or FLAG_FILE_TWO_MODIFIED;

    // Update user interface
    ModificationFlagsChanged;
    DiffLineListChanged;
  end
  else begin
    // Did nothing, free resources and exit
    UB.Free;
  end;
end;

procedure TMainForm.PopPropertiesLeftClick(Sender: TObject);
var
  FP: TPropertiesForm;
begin
  FP := TPropertiesForm.Create( Self );
  FP.SetFiles( FFilename1, FFilename2 );
  FP.ShowModal;
  FP.Free;
end;

procedure TMainForm.DisplayHint(Sender: TObject);
begin
  StatusBar.SimpleText := GetLongHint(Application.Hint);
end;

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
  VK_HOME: SetViewPosition( 0 );
  VK_END: SetViewPosition( VertScrollBar.Max );
  VK_DOWN: SetViewPosition( VertScrollBar.Position + 1 );
  VK_UP: SetViewPosition( VertScrollBar.Position - 1 );
  VK_NEXT: SetViewPosition( VertScrollBar.Position + VertScrollBar.LargeChange );
  VK_PRIOR: SetViewPosition( VertScrollBar.Position - VertScrollBar.LargeChange );
  VK_LEFT: if( HorzScrollBar.Position > 0 ) then HorzScrollBar.Position := HorzScrollBar.Position - 1;
  VK_RIGHT: if( HorzScrollBar.Position < HorzScrollBar.Max ) then HorzScrollBar.Position := HorzScrollBar.Position + 1;
  end;
end;

end.

